from typing import Optional

from core.database import Base
from sqlalchemy import ForeignKey, PrimaryKeyConstraint, String
from sqlalchemy.orm import Mapped, mapped_column


class State(Base):
    __tablename__ = "states"  # GEstados
    __table_args__ = (
        PrimaryKeyConstraint("m3_key", "description", name="states_pkey"),
        {"schema": "public", "extend_existing": True},
    )

    m3_key: Mapped[str] = mapped_column(ForeignKey("public.countries.m3_key"), nullable=False)
    description: Mapped[str] = mapped_column(
        String(50), nullable=False
    )  # valor legal en español
    mex_key: Mapped[Optional[str]] = mapped_column(String(3))    

    def __repr__(self):
        return f"<State(m3_key={self.m3_key}, description={self.description}, mex_key={self.mex_key}, ame_key={self.ame_key})>"
